# SPDX-FileCopyrightText: 2023 2023 CERN (home.cern)
#
# SPDX-License-Identifier: LGPL-2.1-or-later

"""
SPDX-License-Identifier: GPL-3.0-or-later
SPDX-FileCopyrightText: 2020 CERN
"""

import pytest
from subprocess import Popen
import fcntl
import struct
import collections
import ctypes
import pdb
import random
import re
from PyVME.PyVmeDevice import PyVmeDevice
from PyVME.PyVmeDevice import PyVme

CTRV_CHANNELS=range(1, 9)

def ctrv_config_remote_str(config):
    """Build REMOTE configuration string"""
    return "   {{REMOTE {module:d} {channel:d},{start:s},MULTIPLE,KHZ1,0,0,BUS_OUT}}\n".format(**config)

def ctrv_config_str(config):
    cfg = "{\n"
    for ch in range(1, 9):
        cfg += "   {{OUTMSK {:d} {:d},0x{:08x},TTL_POS}}\n".format(config["module"], ch, 1 << ch)
    cfg += "}\n\n{\n"
    print(config)
    if "remote" in config:
        cfg += ctrv_config_remote_str(config["remote"])
    cfg += "}\n\n"

    return cfg

def __ctrv_config_outmask(module):
    cfg = "{\n"
    for ch in CTRV_CHANNELS:
        cfg += "   {{OUTMSK {:d} {:d},0x{:08x},TTL_POS}}\n".format(module, ch, 1 << ch)
    cfg += "}\n\n"
    return cfg

def __ctrv_config_remote(module, channel, start):
    cfg = "{\n"
    cfg += "   {{REMOTE {:d} {:d},{:s},MULTIPLE,KHZ1,0,0,BUS_OUT}}\n".format(module, channel, start)
    cfg += "}\n\n"
    return cfg

def __ctrv_config_module(module, channel, start):
    cfg = __ctrv_config_outmask(module)
    cfg += __ctrv_config_remote(module, channel, start)
    return cfg

def ctrv_config_file(start):
    config_file = "/tmp/ctrv_config"
    cfg = ""
    for ctrv in pytest.VME_CTRV_MODULE:
        cfg += __ctrv_config_module(ctrv, ctrv, start)
        cmd = "echo 'mo {:d} reset q' | /usr/local/bin/ctrtest".format(ctrv)
        Popen([cmd], shell=True)
    with open(config_file, "w") as f_cfg:
        f_cfg.write(cfg)
    cmd = "echo 'ptmrf {:s} ' | /usr/local/bin/ctrtest".format(config_file)
    Popen([cmd], shell=True)

class TestVmebusIrq():
    """VME bus test IRQ"""

    def __vme_bridge_irq_count(self):
        with open("/proc/interrupts", "r") as f_irq:
            proc_irq = f_irq.read()
            m = re.search("\n[0-9]+:(.*)IR-PCI-MSI-edge\s+vme_bridge\n",
                          proc_irq)
            return sum([int(val) for val in m.group(1).split()])

    def __vme_irq_level_count(self, level):
        with open("/proc/vme/interrupts", "r") as f_irq:
            proc_irq = f_irq.read()
            print(proc_irq)
            m = re.search("\nIRQ{:d}\s+([0-9]+)\n".format(level), proc_irq)
            return int(m.group(1))

    @pytest.mark.parametrize("ctrv_n", [range(1, ctrv_n + 1) for ctrv_n in pytest.VME_CTRV_MODULE])
    @pytest.mark.parametrize("start,n_irq_p",
                             [("PPS", i) for i in range(1, 3)] +
                             [("SELF", i) for i in [2**x for x in range(1, 20)]])
    def test_irq(self, ctrv_n, start, n_irq_p):
        """VME bus must be able to handle single and simultaneus
        IRQ. The paramente 'n_irq_p' is the number of IRQ to be
        generate excluded the ones generated by the tool on
        registration"""
        ctrv_config_file(start)

        vme_bridge_irq = {}
        level_irq = {}
        vme_bridge_irq["before"] = self.__vme_bridge_irq_count()
        level_irq["before"] = self.__vme_irq_level_count(2)

        cmd =  "echo \""
        for ctrv in ctrv_n:
            cmd += "mo {:d} wi 0x{:x} ".format(ctrv, 1 << ctrv)  # registration
        cmd += "{:d}(wi 0x2) q\" | /usr/local/bin/ctrtest".format(n_irq_p)

        print(cmd)
        proc = Popen([cmd], shell=True)
        proc.wait()
        vme_bridge_irq["after"] = self.__vme_bridge_irq_count()
        level_irq["after"] = self.__vme_irq_level_count(2)

        # ctrtest genetares one extra interrupt because of
        # 'wi 0x2' (registration)
        irq_diff = vme_bridge_irq["after"] - vme_bridge_irq["before"]
        level_irq_diff = level_irq["after"] - level_irq["before"]
        assert level_irq_diff == len(ctrv_n) + (n_irq_p * len(ctrv_n)) + sum([x for x in range(1, len(ctrv_n))])
        assert irq_diff == len(ctrv_n) + n_irq_p
